import { defaultKeymap as H } from "@codemirror/commands";
import { javascript as A } from "@codemirror/lang-javascript";
import { HighlightStyle as $, syntaxHighlighting as T, defaultHighlightStyle as j } from "@codemirror/language";
import { StateEffect as v, StateField as y, RangeSetBuilder as G, EditorState as K } from "@codemirror/state";
import { Decoration as f, EditorView as g, lineNumbers as W, highlightActiveLineGutter as I, keymap as L } from "@codemirror/view";
import { Drawer as O, repl as P } from "@strudel.cycles/core";
import { tags as e } from "@lezer/highlight";
const p = v.define(), R = y.define({
  create() {
    return f.none;
  },
  update(t, o) {
    try {
      for (let r of o.effects)
        if (r.is(p))
          if (r.value && o.newDoc.length > 0) {
            const n = f.mark({ attributes: { style: "background-color: #FFCA2880" } });
            t = f.set([n.range(0, o.newDoc.length)]);
          } else
            t = f.set([]);
      return t;
    } catch (r) {
      return console.warn("flash error", r), t;
    }
  },
  provide: (t) => g.decorations.from(t)
}), V = (t, o = 200) => {
  t.dispatch({ effects: p.of(!0) }), setTimeout(() => {
    t.dispatch({ effects: p.of(!1) });
  }, o);
}, N = v.define(), F = v.define(), ge = (t, o) => {
  t.dispatch({ effects: N.of(o) });
}, q = (t, o, r) => {
  t.dispatch({ effects: F.of({ atTime: o, haps: r }) });
}, b = y.define({
  create() {
    return f.none;
  },
  update(t, o) {
    o.docChanged && (t = t.map(o.changes));
    for (let r of o.effects)
      if (r.is(N)) {
        const n = r.value.filter(([a]) => a < o.newDoc.length).map(([a, l]) => [a, Math.min(l, o.newDoc.length)]).map(
          (a) => f.mark({
            id: a.join(":"),
            // this green is only to verify that the decoration moves when the document is edited
            // it will be removed later, so the mark is not visible by default
            attributes: { style: "background-color: #00CA2880" }
          }).range(...a)
          // -> Decoration
        );
        t = f.set(n, !0);
      }
    return t;
  }
}), k = y.define({
  create() {
    return { atTime: 0, haps: /* @__PURE__ */ new Map() };
  },
  update(t, o) {
    for (let r of o.effects)
      if (r.is(F)) {
        const n = /* @__PURE__ */ new Map();
        for (let a of r.value.haps)
          for (let { start: l, end: s } of a.context.locations) {
            let i = `${l}:${s}`;
            (!n.has(i) || n.get(i).whole.begin.lt(a.whole.begin)) && n.set(i, a);
          }
        t = { atTime: r.value.atTime, haps: n };
      }
    return t;
  }
}), z = g.decorations.compute([b, k], (t) => {
  const o = t.field(b).iter(), { haps: r } = t.field(k), n = new G();
  for (; o.value; ) {
    const {
      from: a,
      to: l,
      value: {
        spec: { id: s }
      }
    } = o;
    if (r.has(s)) {
      const h = r.get(s).context.color ?? "var(--foreground)";
      n.add(
        a,
        l,
        f.mark({
          // attributes: { style: `outline: solid 2px rgba(${channels.join(', ')})` },
          attributes: { style: `outline: solid 2px ${h}` }
        })
      );
    }
    o.next();
  }
  return n.finish();
}), J = [b, k, z], Q = "#e5c07b", M = "#e06c75", U = "#56b6c2", X = "#ffffff", m = "#abb2bf", w = "#7d8799", Y = "#61afef", Z = "#98c379", D = "#d19a66", _ = "#c678dd", ee = "#21252b", B = "#2c313a", E = "#282c34", u = "#353a42", oe = "#3E4451", S = "#528bff", te = g.theme(
  {
    "&": {
      color: m,
      backgroundColor: E
    },
    ".cm-content": {
      caretColor: S
    },
    ".cm-cursor, .cm-dropCursor": { borderLeftColor: S },
    "&.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground, .cm-selectionBackground, .cm-content ::selection": { backgroundColor: oe },
    ".cm-panels": { backgroundColor: ee, color: m },
    ".cm-panels.cm-panels-top": { borderBottom: "2px solid black" },
    ".cm-panels.cm-panels-bottom": { borderTop: "2px solid black" },
    ".cm-searchMatch": {
      backgroundColor: "#72a1ff59",
      outline: "1px solid #457dff"
    },
    ".cm-searchMatch.cm-searchMatch-selected": {
      backgroundColor: "#6199ff2f"
    },
    ".cm-activeLine": { backgroundColor: "#6699ff0b" },
    ".cm-selectionMatch": { backgroundColor: "#aafe661a" },
    "&.cm-focused .cm-matchingBracket, &.cm-focused .cm-nonmatchingBracket": {
      backgroundColor: "#bad0f847"
    },
    ".cm-gutters": {
      backgroundColor: E,
      color: w,
      border: "none"
    },
    ".cm-activeLineGutter": {
      backgroundColor: B
    },
    ".cm-foldPlaceholder": {
      backgroundColor: "transparent",
      border: "none",
      color: "#ddd"
    },
    ".cm-tooltip": {
      border: "none",
      backgroundColor: u
    },
    ".cm-tooltip .cm-tooltip-arrow:before": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    },
    ".cm-tooltip .cm-tooltip-arrow:after": {
      borderTopColor: u,
      borderBottomColor: u
    },
    ".cm-tooltip-autocomplete": {
      "& > ul > li[aria-selected]": {
        backgroundColor: B,
        color: m
      }
    }
  },
  { dark: !0 }
), re = $.define([
  { tag: e.keyword, color: _ },
  { tag: [e.name, e.deleted, e.character, e.propertyName, e.macroName], color: M },
  { tag: [e.function(e.variableName), e.labelName], color: Y },
  { tag: [e.color, e.constant(e.name), e.standard(e.name)], color: D },
  { tag: [e.definition(e.name), e.separator], color: m },
  { tag: [e.typeName, e.className, e.number, e.changed, e.annotation, e.modifier, e.self, e.namespace], color: Q },
  { tag: [e.operator, e.operatorKeyword, e.url, e.escape, e.regexp, e.link, e.special(e.string)], color: U },
  { tag: [e.meta, e.comment], color: w },
  { tag: e.strong, fontWeight: "bold" },
  { tag: e.emphasis, fontStyle: "italic" },
  { tag: e.strikethrough, textDecoration: "line-through" },
  { tag: e.link, color: w, textDecoration: "underline" },
  { tag: e.heading, fontWeight: "bold", color: M },
  { tag: [e.atom, e.bool, e.special(e.variableName)], color: D },
  { tag: [e.processingInstruction, e.string, e.inserted], color: Z },
  { tag: e.invalid, color: X }
]), ae = [te, T(re)];
function ne({ initialCode: t = "", onChange: o, onEvaluate: r, onStop: n, theme: a = ae, root: l }) {
  let s = K.create({
    doc: t,
    extensions: [
      a,
      A(),
      W(),
      J,
      I(),
      T(j),
      L.of(H),
      R,
      g.updateListener.of((i) => o(i)),
      L.of([
        {
          key: "Ctrl-Enter",
          run: () => r()
        },
        {
          key: "Ctrl-.",
          run: () => n()
        }
      ])
    ]
  });
  return new g({
    state: s,
    parent: l
  });
}
class me {
  constructor(o) {
    const { root: r, initialCode: n = "", onDraw: a, drawTime: l = [-2, 2], prebake: s, ...i } = o;
    this.code = n, this.drawer = new O((c, d) => {
      const C = c.filter((x) => d >= x.whole.begin && d <= x.endClipped);
      this.highlight(C, d), a?.(c, d, C);
    }, l);
    const h = s();
    h.then(async () => {
      if (!a)
        return;
      const { scheduler: c, evaluate: d } = await this.repl;
      h.then(async () => {
        await d(this.code, !1), this.drawer.invalidate(c), a?.(this.drawer.visibleHaps, 0, []);
      });
    }), this.repl = P({
      ...i,
      onToggle: async (c) => {
        i?.onToggle?.(c);
        const { scheduler: d } = await this.repl;
        c ? this.drawer.start(d) : this.drawer.stop();
      },
      beforeEval: async () => {
        await h;
      },
      afterEval: (c) => {
        i?.afterEval?.(c), this.drawer.invalidate();
      }
    }), this.editor = ne({
      root: r,
      initialCode: n,
      onChange: (c) => {
        this.code = c.state.doc.toString();
      },
      onEvaluate: () => this.evaluate(),
      onStop: () => this.stop()
    });
  }
  async evaluate() {
    const { evaluate: o } = await this.repl;
    this.flash(), await o(this.code);
  }
  async stop() {
    const { scheduler: o } = await this.repl;
    o.stop();
  }
  flash(o) {
    V(this.editor, o);
  }
  highlight(o, r) {
    q(this.editor.view, r, o);
  }
}
export {
  me as StrudelMirror,
  V as flash,
  R as flashField,
  J as highlightExtension,
  q as highlightMiniLocations,
  ne as initEditor,
  p as setFlash,
  N as setMiniLocations,
  F as showMiniLocations,
  ge as updateMiniLocations
};
